---
###
# File........: /network/tasks/01_prepare_network_setup.yml
# Description.: Ansible Automation Task: Network - Prepare Network Setup
# Author......: Issac Nolis Ohasi
# Created at..: 20.02.2022 23:48
###
- block:
  - name: "[Network] Backuping main network interfaces file"
    copy:
      src: "{{ interfaces_file_path }}"
      dest: "{{ interfaces_file_path }}.bak.{{ lookup('pipe', 'date +%Y-%m-%dT%H:%M:%S') }}"
      owner: root
      group: root

  - name: "[Network] Preparing backup of current network interfaces definition"
    file:
      path: "{{ backup_interfaces_folder }}"
      state: directory

  - name: "[Network] Backuping current network interfaces definition"
    copy:
      src: "{{ interfaces_folder_path }}/"
      dest: "{{ backup_interfaces_folder }}"

  - name: "[Network] Inventorying current network interface definition"
    find:
      paths: "{{ interfaces_folder_path }}"
      patterns: "*"
    register: interfaces_to_purge

  - name: "[Network] Purging current network interface definition"
      file:
        path: "{{ item.path }}"
        state: absent
    with_items: "{{ interfaces_to_purge.files }}"

  - name: "[Network] Creating network interface configuration file"
    template:
      src: etc/network/interfaces.j2
      dest: "{{ interfaces_file_path }}"
      owner: root
      group: root
      mode: 0644
